unit vlado1; {version 1.04}
interface
  function menu(MenuText:array of string;ueberschrift:string;var menupos:byte;
                MenuMax,xpos,ypos,xbreit:byte;test:boolean):byte;
  function entscheidung(text:string;xpos,ypos:byte;test:boolean):boolean;
  Procedure CsrON;
  Procedure CsrOFF;
  PROCEDURE Mauso(VAR maus:array of word);
  function erweiterung(name: string; soll: string): string;
  function nur_name(name: string): string;
  procedure dir(was:string);
  function datum:string;
  function int2str(zahl:longint):string;
  function str2int(zk:string):longint;
  function gr(zeichenkette:string):string;
  function txtLaenge(zk: string; laenge: byte): string;
  function eingabeFeld( text: string; laenge: byte): string;

implementation
uses
  crt, dos;
var
  m:Array[1..4] Of Word;

function gr(zeichenkette:string): string;
var
  i: byte;
begin
  for i := 1 to length(zeichenkette) do
    zeichenkette[i]:=UpCase(zeichenkette[i]);
  gr:=zeichenkette;
end;

function int2str(zahl:longint):string;
var
  zk:string[11];
begin
  str(zahl,zk);
  int2str:=zk;
end;

function str2int(zk:string):longint;
var
  code:integer;
  zahl:longint;
begin
  val(zk,zahl,code);
  if code=0 then str2int:=zahl else str2int:=0;
end;

function datum:string;
var
  jahr,monat,tag,wochentag:word;
begin
  getdate(jahr,monat,tag,wochentag);
  datum:=int2str(tag)+'.'+int2str(monat)+'.'+int2str(jahr);
end;

function menu(MenuText:array of string;ueberschrift:string;var menupos:byte;
              MenuMax,xpos,ypos,xbreit:byte;test:boolean):byte;
var
  ch:char;
  i,wahl:byte;
  AltMausX,AltMausY:byte;
  dateiname:string;
  function MausPos:real;
  begin
    MausPos:=((m[4] div 8- ypos+2) / 2 );
  end;
  procedure text(mposition,textfarbe,hintergrundfarbe:byte);
  begin
    gotoxy(10,(mposition*2));
    textcolor(textfarbe); textbackground(hintergrundfarbe);
    write(MenuText[mposition-1]);
  end;
  procedure menu_vorbereiten(aktuell:byte);
  var i:integer;
  begin
    csroff;
    window(1,1,80,25);
    gotoxy(10,3);
    textcolor(lightgreen); textbackground(black);
    write(ueberschrift);
    window(xpos,ypos,(xpos+xbreit),(ypos+2*menumax));
    textbackground(blue);
    clrscr;
    for i:=1 to menumax do if i=aktuell then text(i,15,red) else text(i,7,blue);
    menupos:=aktuell;
  end;
begin
  menu_vorbereiten(menupos);
  wahl:=0;
  m[1]:=1; MausO(m);       {1 = sichtbar machen}
  m[1]:=3; MausO(m);       {3 = Daten uebermitteln}
  repeat
    if test then
      begin
        gotoxy(1,1);
        textbackground(blue); textcolor(lightgray);
        WriteLn(' X:',AltMausX :3,'  Y:',AltMausY:3,'  MausPos:',MausPos:1);
      end;
    altmausx:=(m[3] div 8+1);
    altmausy:=(m[4] div 8+1);
    MausO(m);
    if ((altmausx<>(m[3] div 8+1))or(altmausy<>(m[4] div 8+1))) then
      if ((MausPos=round(MausPos))and(MausPos<=menumax)and(MausPos>=1)
        and(altmausx>30)and(altmausx<49)) then  {Text markieren}
           begin
             text(menupos,lightgray,blue);
             menupos:=round(MausPos);
             text(menupos,white,red);
           end;
    if m[2]=1 then
      begin
        repeat mauso(m) until m[2]=0;
        if((altmausx>30)and(altmausx<49)and(mausPos=menupos))then
          if MausPos=menumax then wahl:=menumax else wahl:=menupos;
      end;
    if keypressed then
      begin
        ch:=readkey;
        case ch of
          'H': begin
                 text(menupos,lightgray,blue);
                 if menupos=1 then menupos:=menumax else dec(menupos);
                 text(menupos,white,red);
               end;
          'P': begin
                 text(menupos,lightgray,blue);
                 if menupos=menumax then menupos:=1 else inc(menupos);
                 text(menupos,white,red);
               end;
          chr(13): if menupos = menumax then wahl:=menumax else wahl:=menupos;
          chr(27): wahl:=menumax;
        end;   {von case}
     end;    {von if keypressed}
  until wahl>0;
  if wahl<>menumax then
    begin
      window(1,1,80,25);
      textcolor(lightgray);
      textbackground(black);
      clrscr;
    end;
  menu:=wahl;
end;

function entscheidung(text:string;xpos,ypos:byte;test:boolean):boolean;
var ch:char;
    wahl:boolean;
  procedure markiere(welches:boolean);
  begin
    textbackground(red); textcolor(lightgray);
    if welches then begin gotoxy(29,4); write('nein'); end
               else begin gotoxy(20,4); write(' ja '); end;
    textcolor(white); textbackground(lightblue);
    if welches then begin gotoxy(20,4); write(' ja '); end
               else begin gotoxy(29,4); write('nein'); end;
    wahl:=welches;
  end;
begin
  window(xpos,ypos,(xpos+43),(ypos+5)); textbackground(red); textcolor(lightgray);clrscr;csroff;
  gotoxy(((50-length(text))div 2),2); write(text);
  markiere(true);
  repeat
    ch:='x';
    gotoxy(1,1);
    mauso(m);
    if test then WriteLn(' X:',m[3] :3,'  Y:',m[4]:3);
    if ((m[4]=16+ypos*8)and(m[3]>(143+xpos*8))and(m[3]<(169+xpos*8)))then
      begin                                       {Ja?}
        markiere(true);
        if m[2]=1 then ch:=char(13);
      end;
    if ((m[4]=(16+ypos*8))and(m[3]>(215+xpos*8))and(m[3]<(241+xpos*8)))then
      begin                                       {Nein?}
        markiere(false);
        if m[2]=1 then ch:=char(13);
      end;
    if m[2]=1 then repeat mauso(m) until m[2]=0;
    if keypressed then
      begin
        ch:=readkey;
        case ch of
          char(75),char(77): markiere(not(wahl));
          char(27): begin
                      markiere(false);
                      ch:=char(13);
                    end;
        end;
      end;
  until ord(ch)=13;
  csron;window(1,1,80,25);textbackground(black);textcolor(lightgray);clrscr;
  entscheidung := wahl;
end;

function erweiterung(name: string; soll: string): string;
var
  i: byte;
  so_lassen: boolean;
begin
  so_lassen:= true;
  for i:=0 to (length(soll)-1) do
    if upcase(name[length(name) - i]) <> upcase(soll[length(soll) - i])
    then so_lassen:= false;
  for i:= length(name) downto 0 do {2 Punkte im Dateinamen erlaubt DOS nicht}
    if name[i] = '.' then so_lassen:= true;
  if so_lassen then erweiterung:= name else erweiterung:= (name + soll);
end;

function nur_name(name: string): string;
var
  hilf: string;
  i: byte;
begin
  hilf:= '';
  i:= length(name);
  if name <> '' then
  repeat
    if name[i] = '.' then hilf:='' else hilf:= name[i] + hilf;
    dec(i);
  until ((name[i] = '\') or (i = 0));
  nur_name:= hilf;
end;

function txtLaenge(zk: string; laenge: byte): string;
begin
  if length(zk) > laenge then delete(zk, (laenge + 1), (length(zk) - laenge)) else
    while length(zk) < laenge do zk:= zk + ' ';
  txtLaenge:= zk;
end;

procedure dir(was:string);
var
  DirInfo: SearchRec;
begin
  writeln('Im aktuellen Verzeichniss gibt',chr(39),'s schon:');
  FindFirst(was, Archive, DirInfo);
  while DosError = 0 do
    begin
      Writeln(DirInfo.Name);
      FindNext(DirInfo);
    end;
  writeln;
end;

PROCEDURE Mauso(VAR maus:array of word);
BEGIN
  ASM
    LES DI,maus
    MOV AX,ES:[DI]
    MOV BX,ES:[DI+2]
    MOV CX,ES:[DI+4]
    MOV DX,ES:[DI+6]
    INT $33
    MOV ES:[DI],AX
    MOV ES:[DI+2],BX
    MOV ES:[DI+4],CX
    MOV ES:[DI+6],DX
  END;
END;

Procedure CsrON;Assembler;
asm
  mov ah,01h
  mov ch,6
  mov cl,7
  int 10h
end;

Procedure CsrOFF;Assembler;
asm
  mov ah,01h
  mov ch,7
  mov cl,0
  int 10h
end;

function eingabeFeld( text: string; laenge: byte ): string;
var
  xPos, yPos: byte;
  eingabe: string;
begin
  write( text, '(', laenge, ' Stellen): ' );
  xPos := whereX;
  yPos := whereY;
  window( xPos, yPos, (xPos + laenge - 1), yPos );
  textbackground( BLUE );
  clrscr;
  window( 1, 1, 80, 25 );
  gotoxy( xPos, yPos );
  readln( eingabe );
  delete( eingabe, laenge + 1, length(eingabe) - laenge);
  gotoxy( xPos, yPos );
  write( eingabe );
  textbackground( BLACK );
  clreol;
  writeln;
  eingabeFeld := eingabe;
end;

end.